"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceBalanceList = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importStar(require("react"));
const GovernanceBalanceList_style_1 = require("../../components/GovernanceBalanceList/GovernanceBalanceList.style");
const constants_1 = require("../../constants");
const GovernanceBalanceList = (props) => {
    const { balances, viewUtils, containerClassName } = props;
    const tokenLogoRef = (0, react_1.useRef)(null);
    const classes = (0, GovernanceBalanceList_style_1.useStyles)();
    return (react_1.default.createElement(core_1.Box, { className: `${classes.container} ${containerClassName}` }, balances === null || balances === void 0 ? void 0 : balances.map((balance, index) => (react_1.default.createElement(core_1.Box, { key: index, className: `${classes.itemWrapper}` },
        react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center" },
            react_1.default.createElement("img", { className: classes.tokenLogo, src: balance.symbol === "HYPR" ||
                    balance.symbol === "H" ||
                    balance.symbol === "HPT"
                    ? constants_1.HYPER_TOKEN_LOGO_URL
                    : `https://cryptoicon-api.vercel.app/api/icon/${balance.symbol.toLocaleLowerCase()}`, ref: tokenLogoRef, onError: () => {
                    var _a;
                    (_a = tokenLogoRef.current) === null || _a === void 0 ? void 0 : _a.setAttribute("src", constants_1.HYPER_TOKEN_LOGO_URL);
                } }),
            react_1.default.createElement(core_1.Typography, { variant: "subtitle2" }, balance.name.toUpperCase())),
        react_1.default.createElement(core_1.Box, { display: "flex" },
            react_1.default.createElement(core_1.Typography, { variant: "subtitle2", color: "textPrimary", className: classes.tokenAmount }, viewUtils.convertToEther(balance.freeAmount)),
            react_1.default.createElement(core_1.Tooltip, { title: balance.name, placement: "top" },
                react_1.default.createElement(core_1.Typography, { variant: "subtitle2", color: "textSecondary" }, balance.symbol))))))));
};
exports.GovernanceBalanceList = GovernanceBalanceList;
//# sourceMappingURL=GovernanceBalanceList.js.map