"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceDialog = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const GovernanceDialog_style_1 = require("../../components/GovernanceDialog/GovernanceDialog.style");
const GovernanceDialog = (props) => {
    const { title, description, content, isOpen, onClose, maxWidth = "sm", ...rest } = props;
    const classes = (0, GovernanceDialog_style_1.useStyles)();
    const [isDialogOpen, setIsDialogOpen] = (0, react_1.useState)(isOpen);
    const toggleDialogOpen = () => {
        setIsDialogOpen((open) => !open);
    };
    if (!isDialogOpen) {
        return null;
    }
    return (react_1.default.createElement(core_1.Dialog, { className: classes.dialog, open: isDialogOpen, onClose: () => {
            setIsDialogOpen(false);
            onClose && onClose();
        }, fullWidth: true, maxWidth: maxWidth, onClick: (e) => {
            e.stopPropagation();
        }, ...rest },
        react_1.default.createElement(core_1.Box, { className: classes.dialogTitle },
            title,
            react_1.default.createElement(core_1.IconButton, { "aria-label": "close", onClick: () => {
                    setIsDialogOpen(false);
                    onClose && onClose();
                } },
                react_1.default.createElement(icons_1.Close, null))),
        react_1.default.createElement(core_1.Divider, null),
        react_1.default.createElement(core_1.DialogContent, { className: classes.dialogContent }, content)));
};
exports.GovernanceDialog = GovernanceDialog;
//# sourceMappingURL=GovernanceDialog.js.map