"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const core_1 = require("@material-ui/core");
const theme_1 = require("../../theme");
exports.useStyles = (0, core_1.makeStyles)((theme) => ({
    wrapper: (props) => ({
        marginBottom: 24,
        cursor: "pointer",
        textAlign: "left",
        wordBreak: "break-word",
    }),
    dialogTitle: {
        display: "flex",
        alignItems: "center",
        justifyContent: "space-between",
        flexDirection: "row-reverse",
        fontSize: theme_1.EFontSize.H4,
    },
    list: {
        padding: "24px 40px",
    },
    listItem: {
        padding: "12px 16px",
        "&:hover": {
            backgroundColor: theme_1.colors.GRAY200,
            borderRadius: 3,
        },
    },
    title: {
        marginBottom: 8,
    },
    field: {
        width: "100%",
        color: theme.palette.text.primary,
        fontSize: theme_1.EFontSize.BODY2,
        "&::placeholder": {
            /* Chrome, Firefox, Opera, Safari 10.1+ */
            color: theme_1.colors.GRAY500,
            opacity: 1 /* Firefox */,
        },
        "&:-ms-input-placeholder": {
            /* Internet Explorer 10-11 */
            color: theme_1.colors.GRAY500,
        },
        "&::-ms-input-placeholder": {
            /* Microsoft Edge */
            color: theme_1.colors.GRAY500,
        },
    },
    fieldTextWrapper: {
        display: "flex",
        justifyContent: "space-between",
        border: `2px solid ${theme_1.colors.GRAY300}`,
        padding: "12px 16px",
        borderRadius: 3,
        background: theme_1.colors.GRAY100,
        alignItems: "center",
    },
    smallFieldTextWrapper: {
        padding: "4px 10px 4px 10px",
    },
    dialogCloseButton: {
        marginLeft: "auto",
    },
}));
//# sourceMappingURL=GovernanceDialogSelectField.style.js.map