"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceField = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const formik_1 = require("formik");
const GovernanceField_style_1 = require("../../components/GovernanceField/GovernanceField.style");
const CustomizedSelectForFormik = ({ children, form, field }) => {
    const classes = (0, GovernanceField_style_1.useStyles)({});
    const { name } = field;
    const { setFieldValue } = form;
    return (react_1.default.createElement(core_1.Select, { ...field === null || field === void 0 ? void 0 : field.props, required: field === null || field === void 0 ? void 0 : field.required, name: field === null || field === void 0 ? void 0 : field.name, value: field === null || field === void 0 ? void 0 : field.value, variant: "outlined", className: classes.field, style: { padding: 0 }, fullWidth: true, onChange: (e) => {
            setFieldValue(name, e.target.value);
        } }, children));
};
const GovernanceField = (props) => {
    const { title, type = "input", required, options, focus, rightContent, handleChange, className, } = props;
    const classes = (0, GovernanceField_style_1.useStyles)({});
    const titleText = `${title}${required ? " *" : ""}`;
    const isSelect = type === "select";
    const inputRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        var _a;
        if (focus) {
            (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    }, []);
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        title && (react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary", className: classes.title }, titleText)),
        !isSelect ? (react_1.default.createElement(core_1.Box, { className: classes.fieldWrapper },
            react_1.default.createElement(formik_1.Field, { innerRef: inputRef, ...props, className: `${classes.field} ${className}`, component: type }),
            rightContent && (react_1.default.createElement(core_1.Box, { className: classes.rightContent }, rightContent)))) : (react_1.default.createElement(formik_1.Field, { ...props, component: CustomizedSelectForFormik }, (options === null || options === void 0 ? void 0 : options.length) ? (options.map((option) => (react_1.default.createElement(core_1.MenuItem, { value: option.value, onClick: () => {
                handleChange === null || handleChange === void 0 ? void 0 : handleChange(option.value);
            } },
            react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center", p: 0 }, option.label))))) : (react_1.default.createElement(core_1.MenuItem, { value: "" }))))));
};
exports.GovernanceField = GovernanceField;
//# sourceMappingURL=GovernanceField.js.map