"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceRegistryListItem = void 0;
const react_1 = __importDefault(require("react"));
const components_1 = require("../../components");
const components_2 = require("../../components");
const core_1 = require("@material-ui/core");
const GovernanceRegistryListItem_style_1 = require("../../components/GovernanceRegistryListItem/GovernanceRegistryListItem.style");
const GovernanceRegistryListItem = (props) => {
    const { number, title, fieldWithValueList, actionButtonList = [], chipItemList = [], } = props;
    const classes = (0, GovernanceRegistryListItem_style_1.useStyles)();
    return (react_1.default.createElement(components_1.GovernanceListItem, { number: number, title: title, rightContent: actionButtonList.map(({ onClick, label, variant = "contained", size = "small", ...rest }, index) => (react_1.default.createElement(components_1.GovernanceButton, { className: classes.listItemRightButton, onClick: onClick, variant: variant, size: size, key: index, ...rest }, label))) },
        react_1.default.createElement(core_1.Grid, { container: true, spacing: 3 }, fieldWithValueList.map(({ fieldTitle, fieldValue, fullWidth }, index) => (react_1.default.createElement(core_1.Grid, { key: index, className: classes.gridItem, item: true, xs: fullWidth ? 12 : 6 }, fieldValue && (react_1.default.createElement(components_2.GovernanceListItemValueWithTitle, { title: fieldTitle, value: fieldValue })))))),
        chipItemList.length > 0 && (react_1.default.createElement(core_1.Grid, { container: true, spacing: 1 }, chipItemList.map((item, index) => (react_1.default.createElement(core_1.Grid, { key: index, item: true },
            react_1.default.createElement(components_1.GovernanceChip, { label: item, color: "orange", size: "small" }))))))));
};
exports.GovernanceRegistryListItem = GovernanceRegistryListItem;
//# sourceMappingURL=GovernanceRegistryListItem.js.map