"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceStatusTag = void 0;
const react_1 = __importDefault(require("react"));
const core_1 = require("@material-ui/core");
const GovernanceTag_1 = require("../../components/GovernanceTag");
const objects_1 = require("@hypernetlabs/objects");
const GovernanceStatusTag = (props) => {
    const { status } = props;
    const { text, color } = getStatusConfig(status);
    return (react_1.default.createElement(core_1.Box, { width: 92 },
        react_1.default.createElement(GovernanceTag_1.GovernanceTag, { text: text, color: color })));
};
exports.GovernanceStatusTag = GovernanceStatusTag;
const getStatusConfig = (status) => {
    switch (Number(status)) {
        case objects_1.EProposalState.PENDING:
            return {
                color: GovernanceTag_1.ETagColor.BLUE,
                text: "Pending",
            };
        case objects_1.EProposalState.ACTIVE:
            return {
                color: GovernanceTag_1.ETagColor.PURPLE,
                text: "Active",
            };
        case objects_1.EProposalState.SUCCEEDED:
            return {
                color: GovernanceTag_1.ETagColor.BLUE,
                text: "Succeeded",
            };
        case objects_1.EProposalState.EXECUTED:
            return {
                color: GovernanceTag_1.ETagColor.GREEN,
                text: "Executed",
            };
        case objects_1.EProposalState.DEFEATED:
            return {
                color: GovernanceTag_1.ETagColor.RED,
                text: "Defeated",
            };
        case objects_1.EProposalState.QUEUED:
            return {
                color: GovernanceTag_1.ETagColor.GRAY,
                text: "Queued",
            };
        case objects_1.EProposalState.CANCELED:
            return {
                color: GovernanceTag_1.ETagColor.GRAY,
                text: "Cancelled",
            };
        case objects_1.EProposalState.EXPIRED:
            return {
                color: GovernanceTag_1.ETagColor.GRAY,
                text: "Expired",
            };
        default:
            return {
                color: GovernanceTag_1.ETagColor.GRAY,
                text: "Undetermined",
            };
    }
};
//# sourceMappingURL=GovernanceStatusTag.js.map