"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const core_1 = require("@material-ui/core");
const hooks_1 = require("../../hooks");
const theme_1 = require("../../theme");
const useStyles = () => {
    const widgetUniqueIdentifier = (0, hooks_1.useWidgetUniqueIdentifier)();
    const styles = (0, core_1.makeStyles)(() => ({
        wrapper: {
            display: "flex",
            flexDirection: "column",
        },
        listItem: () => ({
            display: "flex",
            flexDirection: "row",
            padding: "16px 0",
            [`& .${widgetUniqueIdentifier}MuiListItemIcon-root`]: {
                minWidth: "unset",
                marginRight: 20,
            },
        }),
        rightContent: {
            marginLeft: "auto",
        },
        divider: {
            color: theme_1.colors.GRAY150,
        },
    }));
    return styles();
};
exports.useStyles = useStyles;
//# sourceMappingURL=ListItem.style.js.map