"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const MetamaskInstructions_style_1 = require("../../components/MetamaskInstructions/MetamaskInstructions.style");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const constants_1 = require("../../constants");
const MetamaskInstructions = () => {
    const classes = (0, MetamaskInstructions_style_1.useStyles)();
    const { setModalHeader, setHideModalWatermark } = (0, contexts_1.useLayoutContext)();
    (0, react_1.useEffect)(() => {
        setModalHeader("Wallet Connection and Signing");
        setHideModalWatermark(true);
        return () => {
            setModalHeader("");
            setHideModalWatermark(false);
        };
    }, []);
    return (react_1.default.createElement(core_1.Box, { display: "flex", flexDirection: "column" },
        react_1.default.createElement(components_1.GovernanceTypography, { variant: "h4", className: classes.description }, "Use the MetaMask pop-up window at the right to:"),
        react_1.default.createElement(core_1.Box, { display: "flex", justifyContent: "space-between" },
            react_1.default.createElement(core_1.Box, { display: "flex", flexDirection: "column" },
                react_1.default.createElement(core_1.Box, { className: classes.iconContainer },
                    react_1.default.createElement("img", { src: constants_1.WALLET_LIGHT_ICON_URL, className: classes.icon })),
                react_1.default.createElement(components_1.GovernanceTypography, { variant: "body1", className: classes.step }, "1. Connect your Metamask account")),
            react_1.default.createElement(core_1.Box, { display: "flex", flexDirection: "column" },
                react_1.default.createElement(core_1.Box, { className: classes.iconContainer },
                    react_1.default.createElement("img", { src: constants_1.USER_LIGHT_ICON_URL, className: classes.icon })),
                react_1.default.createElement(components_1.GovernanceTypography, { variant: "body1", className: classes.step }, "2. Sign to initialize a payment account")),
            react_1.default.createElement(core_1.Box, { display: "flex", flexDirection: "column" },
                react_1.default.createElement(core_1.Box, { className: classes.iconContainer },
                    react_1.default.createElement("img", { src: constants_1.CREDIT_CARD_LIGHT_ICON_URL, className: classes.icon })),
                react_1.default.createElement(components_1.GovernanceTypography, { variant: "body1", className: classes.step }, "3. Sign to payment gateway")))));
};
exports.default = MetamaskInstructions;
//# sourceMappingURL=MetamaskInstructions.js.map