"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetamaskWarning = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const MetamaskWarning_style_1 = require("../../components/MetamaskWarning/MetamaskWarning.style");
const constants_1 = require("../../constants");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const MetamaskWarning = ({ retry, }) => {
    const classes = (0, MetamaskWarning_style_1.useStyles)();
    const { setModalHeader } = (0, contexts_1.useLayoutContext)();
    const [installClicked, setInstallClicked] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        setModalHeader("Wallet Connection");
    }, []);
    const redirectToMetamaskInstallation = () => {
        window.open(constants_1.METAMASK_DOWNLOAD_URL, "_blank");
    };
    const handleRetry = () => {
        var _a;
        // Check if metamask is still not initialized
        if (!((_a = window) === null || _a === void 0 ? void 0 : _a.ethereum)) {
            redirectToMetamaskInstallation();
            return;
        }
        retry === null || retry === void 0 ? void 0 : retry();
    };
    if (installClicked) {
        return (react_1.default.createElement("div", { className: classes.wrapper },
            react_1.default.createElement(components_1.GovernanceTypography, { variant: "subtitle1" }, "If you are done installing MetaMask, continue."),
            react_1.default.createElement(core_1.Box, { className: classes.metamaskImgWrapper },
                react_1.default.createElement("img", { className: classes.metamaskImg, src: constants_1.METAMASK_LOGO_IMAGE_URL })),
            react_1.default.createElement(components_1.GovernanceButton, { className: classes.continueButton, color: "primary", variant: "contained", size: "medium", fullWidth: true, onClick: handleRetry }, "Continue"),
            react_1.default.createElement(components_1.GovernanceButton, { color: "primary", variant: "outlined", size: "medium", fullWidth: true, onClick: redirectToMetamaskInstallation }, "Install Metamask")));
    }
    return (react_1.default.createElement("div", { className: classes.wrapper },
        react_1.default.createElement(components_1.GovernanceTypography, { variant: "subtitle1" }, "Looks like you don't have metamask installed."),
        react_1.default.createElement(core_1.Box, { className: classes.metamaskImgWrapper },
            react_1.default.createElement("img", { className: classes.metamaskImg, src: constants_1.METAMASK_LOGO_IMAGE_URL })),
        react_1.default.createElement(components_1.GovernanceButton, { color: "primary", variant: "contained", size: "medium", fullWidth: true, onClick: () => {
                setInstallClicked(true);
                redirectToMetamaskInstallation();
            } }, "Install Metamask")));
};
exports.MetamaskWarning = MetamaskWarning;
//# sourceMappingURL=MetamaskWarning.js.map