"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AntTab = exports.AntTabs = exports.TabPanel = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const TabPanel = ({ children, value, index, ...other }) => {
    return (react_1.default.createElement("div", { role: "tabpanel", hidden: value !== index, id: `scrollable-auto-tabpanel-${index}`, "aria-labelledby": `scrollable-auto-tab-${index}`, ...other }, value === index && react_1.default.createElement(core_1.Box, null, children)));
};
exports.TabPanel = TabPanel;
exports.AntTabs = (0, core_1.withStyles)({
    root: {
        borderBottom: "1px solid #e8e8e8",
        boxShadow: "none",
    },
    indicator: {
        backgroundColor: "#1890ff",
    },
})(core_1.Tabs);
exports.AntTab = (0, core_1.withStyles)((theme) => ({
    root: {
        textTransform: "none",
        minWidth: 72,
        fontWeight: theme.typography.fontWeightRegular,
        marginRight: theme.spacing(4),
        fontFamily: [
            "-apple-system",
            "BlinkMacSystemFont",
            '"Segoe UI"',
            "Roboto",
            '"Helvetica Neue"',
            "Arial",
            "sans-serif",
            '"Apple Color Emoji"',
            '"Segoe UI Emoji"',
            '"Segoe UI Symbol"',
        ].join(","),
        "&:hover": {
            color: "#40a9ff",
            opacity: 1,
        },
        "&$selected": {
            color: "#1890ff",
            fontWeight: theme.typography.fontWeightMedium,
        },
        "&:focus": {
            color: "#40a9ff",
        },
    },
    selected: {},
}))((props) => react_1.default.createElement(core_1.Tab, { disableRipple: true, ...props }));
//# sourceMappingURL=Tabs.js.map