"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const ConnectorAuthorizationFlow_style_1 = require("../../flows/ConnectorAuthorizationFlow/ConnectorAuthorizationFlow.style");
const hooks_1 = require("../../hooks");
const theme_1 = require("../../theme");
const BalancesWidget_1 = __importDefault(require("../../widgets/BalancesWidget/BalancesWidget"));
const ConnectorAuthorizationFlow = (props) => {
    const { connectorUrl } = props;
    const { balances } = (0, hooks_1.useBalances)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setModalWidth, setModalStatus, closeModal } = (0, contexts_1.useLayoutContext)();
    const classes = (0, ConnectorAuthorizationFlow_style_1.useStyles)();
    (0, react_1.useEffect)(() => {
        coreProxy.onGatewayAuthorized.subscribe(() => {
            closeModal();
        });
        // Destroy self modal if gateway modal is visible.
        const iframeElements = document.getElementsByName("hypernet-core-gateway-connector-iframe");
        if (iframeElements.length &&
            iframeElements[0].style.display === "block") {
            closeModal();
        }
        coreProxy.onAuthorizedGatewayActivationFailed.subscribe(() => {
            // show some error
            console.log("onAuthorizedGatewayActivationFailed");
        });
    }, []);
    const handleGatewayAuthorization = () => {
        coreProxy.payments.authorizeGateway(connectorUrl).match(() => {
            setModalWidth(565);
            setModalStatus(theme_1.EStatusColor.SUCCESS);
        }, (err) => {
            console.log("yo stop, we have some error");
        });
    };
    return (react_1.default.createElement(core_1.Box, { className: classes.container },
        (balances === null || balances === void 0 ? void 0 : balances.length) ? (react_1.default.createElement(core_1.Box, null,
            react_1.default.createElement(core_1.Box, { className: classes.balancesLabel }, "Your Balances"),
            react_1.default.createElement(BalancesWidget_1.default, null))) : (react_1.default.createElement(core_1.Box, { className: classes.balancesEmptyLabel }, "You are one step away!")),
        react_1.default.createElement(components_1.Button, { label: "Authorize Gateway", onClick: handleGatewayAuthorization, fullWidth: true, bgColor: "linear-gradient(98deg, rgba(0,120,255,1) 0%, rgba(126,0,255,1) 100%)" }),
        react_1.default.createElement(components_1.ModalFooter, null)));
};
exports.default = ConnectorAuthorizationFlow;
//# sourceMappingURL=ConnectorAuthorizationFlow.js.map