"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../../../contexts");
const react_1 = __importStar(require("react"));
const components_1 = require("../../../../components");
const OnboardingSuccess_style_1 = require("../../../../flows/OnboardingFlow/screens/OnboardingSuccess/OnboardingSuccess.style");
const hooks_1 = require("../../../../hooks");
const components_2 = require("../../../../components");
const OnboardingSuccess = (props) => {
    const { successButtonProps, handleFundButtonClick } = props;
    const { closeModal, setModalHeader } = (0, contexts_1.useLayoutContext)();
    const { balances } = (0, hooks_1.useBalances)();
    const { viewUtils } = (0, contexts_1.useStoreContext)();
    const classes = (0, OnboardingSuccess_style_1.useStyles)();
    (0, react_1.useEffect)(() => {
        setModalHeader("Current Balance");
        return () => {
            setModalHeader("");
        };
    }, []);
    const onSuccessButtonClick = () => {
        successButtonProps === null || successButtonProps === void 0 ? void 0 : successButtonProps.action();
        closeModal();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(components_2.GovernanceTypography, { className: classes.subtitle, variant: "subtitle1", align: "left" }, "You are now ready to make instant and secure payments in crypto!"),
        react_1.default.createElement(components_2.GovernanceTypography, { className: classes.subtitle, variant: "subtitle1", align: "left" }, "You can see the available balances in your Hypernet account."),
        react_1.default.createElement(core_1.Box, { display: "flex" },
            react_1.default.createElement(components_1.GovernanceBalanceList, { viewUtils: viewUtils, balances: balances, containerClassName: classes.balanceListContainer })),
        react_1.default.createElement(components_2.GovernanceButton, { className: classes.successButton, color: "primary", variant: "contained", fullWidth: true, onClick: onSuccessButtonClick }, (successButtonProps === null || successButtonProps === void 0 ? void 0 : successButtonProps.label) || "Done"),
        react_1.default.createElement(components_2.GovernanceButton, { className: classes.fundButton, fullWidth: true, variant: "outlined", color: "primary", onClick: handleFundButtonClick }, "Fund My Hypernet Account")));
};
exports.default = OnboardingSuccess;
//# sourceMappingURL=OnboardingSuccess.js.map