import { ChainId, IHypernetCore, IUIData, RenderError, Theme } from "@hypernetlabs/objects";
import { IHypernetWebUI, IRenderParams, IViewUtils, IDateUtils, IHypernetPaymentsWebUI, IHypernetGovernanceWebUI, IHypernetRegistriesWebUI } from "../../interfaces";
import { Result } from "neverthrow";
export default class HypernetWebUI implements IHypernetWebUI {
    private static instance;
    protected coreInstance: IHypernetCore;
    protected UIData: IUIData;
    protected viewUtils: IViewUtils;
    protected dateUtils: IDateUtils;
    protected defaultGovernanceChainId: ChainId;
    protected theme: Theme | null;
    constructor(_coreInstance: IHypernetCore, _UIData: IUIData, iframeURL: string | null, defaultGovernanceChainId: number | null, theme: Theme | null, debug: boolean | null);
    private _generateDomElement;
    private _removeExistedElement;
    private _bootstrapComponent;
    private _getThrowableRender;
    renderPrivateKeysModal(): Result<void, RenderError>;
    renderMetamaskWarningModal(): Result<void, RenderError>;
    renderWalletConnectWidget(config: IRenderParams): Result<void, RenderError>;
    renderChainSelectorWidget(config: IRenderParams): Result<void, RenderError>;
    renderWarningAlertModal(errorMessage?: string): Result<void, RenderError>;
    renderConnectedAccountWidget(config?: IRenderParams): Result<void, RenderError>;
    payments: IHypernetPaymentsWebUI;
    governance: IHypernetGovernanceWebUI;
    registries: IHypernetRegistriesWebUI;
}
//# sourceMappingURL=HypernetWebUI.d.ts.map