"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const react_1 = __importDefault(require("react"));
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const BalancesSummaryWidget_style_1 = require("../../widgets/BalancesSummaryWidget/BalancesSummaryWidget.style");
const BalancesSummaryWidget = ({ noLabel, excludeCardWrapper, }) => {
    const { loading, balancesByChannelAddresses } = (0, hooks_1.useBalances)();
    const { viewUtils } = (0, contexts_1.useStoreContext)();
    const classes = (0, BalancesSummaryWidget_style_1.useStyles)();
    const channelAddresses = [...balancesByChannelAddresses.keys()];
    if (channelAddresses.length === 0 && !loading) {
        return (react_1.default.createElement(components_1.GovernanceCard, null,
            react_1.default.createElement(components_1.GovernanceEmptyState, { title: "Oops..!", description: "You don't have any Hypernet account yet, you need to authorize a gateway first." })));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Grid, { container: true, spacing: 3 }, channelAddresses.map((channelAddress) => (react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
            react_1.default.createElement(components_1.GovernanceCard, { title: !noLabel
                    ? `Your Balances for Hypernet Account Address: ${channelAddress}`
                    : undefined, description: !noLabel
                    ? "The current balance of your Hypernet Account."
                    : undefined }, balancesByChannelAddresses.get(channelAddress) ? (react_1.default.createElement(components_1.GovernanceBalanceList, { balances: balancesByChannelAddresses.get(channelAddress), viewUtils: viewUtils })) : (react_1.default.createElement(core_1.Typography, null, "No balances yet for this channel address")))))))));
};
exports.default = BalancesSummaryWidget;
//# sourceMappingURL=BalancesSummaryWidget.js.map