"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const contexts_1 = require("../../contexts");
const react_1 = __importDefault(require("react"));
const core_1 = require("@material-ui/core");
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const BalancesWidget_style_1 = require("../../widgets/BalancesWidget/BalancesWidget.style");
const BalancesWidget = ({ noLabel, excludeCardWrapper, }) => {
    const { loading, balancesByChannelAddress } = (0, hooks_1.useBalances)();
    const { viewUtils } = (0, contexts_1.useStoreContext)();
    const classes = (0, BalancesWidget_style_1.useStyles)();
    return (react_1.default.createElement(components_1.GovernanceCard, { ...(excludeCardWrapper && { className: classes.nudeCard }), hideDivider: excludeCardWrapper, title: !noLabel ? "Your Balances" : undefined, description: !noLabel
            ? "Available token balances in this Hypernet account."
            : undefined }, balancesByChannelAddress.length === 0 && !loading ? (react_1.default.createElement(core_1.Box, { display: "flex", justifyContent: "center" },
        react_1.default.createElement(components_1.GovernanceEmptyState, { title: "Oops..!", description: react_1.default.createElement(core_1.Typography, { variant: "body2" },
                "You don't have any balances yet, you can Fund your account from",
                react_1.default.createElement("a", { href: "/deposit-and-withdraw" }, " here. ")) }))) : (react_1.default.createElement(components_1.GovernanceBalanceList, { balances: balancesByChannelAddress, viewUtils: viewUtils }))));
};
exports.default = BalancesWidget;
//# sourceMappingURL=BalancesWidget.js.map