"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const core_1 = require("@material-ui/core");
const theme_1 = require("../../theme");
exports.useStyles = (0, core_1.makeStyles)((theme) => ({
    wrapper: (props) => ({
        padding: 8,
        border: `1px solid ${theme_1.colors.PURPLE400}`,
        borderRadius: 3,
        cursor: "pointer",
        textAlign: "left",
    }),
    dialogTitle: {
        display: "flex",
        alignItems: "center",
        justifyContent: "space-between",
        fontSize: theme_1.EFontSize.H4,
    },
    list: {
        padding: "24px 40px",
    },
    listItem: {
        padding: "12px 16px",
        "&:hover": {
            backgroundColor: theme_1.colors.GRAY200,
            borderRadius: 3,
        },
    },
    title: {
        marginBottom: 28,
    },
    field: {
        width: "100%",
        border: "none",
        background: "transparent",
        outline: "none",
        color: theme.palette.text.primary,
        fontSize: theme_1.EFontSize.BODY2,
        "&::placeholder": {
            /* Chrome, Firefox, Opera, Safari 10.1+ */
            color: theme_1.colors.GRAY500,
            opacity: 1 /* Firefox */,
        },
        "&:-ms-input-placeholder": {
            /* Internet Explorer 10-11 */
            color: theme_1.colors.GRAY500,
        },
        "&::-ms-input-placeholder": {
            /* Microsoft Edge */
            color: theme_1.colors.GRAY500,
        },
    },
    fieldTextWrapper: {
        display: "flex",
        justifyContent: "space-between",
        alignItems: "center",
    },
    switchChainButton: (props) => ({
        padding: 8,
        border: `1px solid ${theme_1.colors.STATUS_RED}`,
        borderRadius: 3,
        cursor: "pointer",
        textAlign: "left",
        marginLeft: 15,
    }),
}));
//# sourceMappingURL=ChainSelectorWidget.style.js.map