"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const formik_1 = require("formik");
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const FundWidget_style_1 = require("../../widgets/FundWidget/FundWidget.style");
const FundWidget = ({ noHeader, noLabel, excludeCardWrapper, selectType = "dialog", }) => {
    var _a, _b;
    const { tokenSelectorOptions, error, depositFunds, activeStateChannels = [], stateChannelsFetched, selectedStateChennel, } = (0, hooks_1.useFund)();
    const classes = (0, FundWidget_style_1.useStyles)({ error });
    const handleFormSubmit = (values) => {
        depositFunds(values.tokenAddress, values.amount, values.stateChannelAddress);
    };
    const uniqueActiveStateChannels = (0, react_1.useMemo)(() => activeStateChannels.filter((stateChannel, index, self) => {
        return (index ===
            self.findIndex((item) => item.channelAddress === stateChannel.channelAddress));
    }), [JSON.stringify(activeStateChannels)]);
    if (!stateChannelsFetched) {
        return null;
    }
    return (react_1.default.createElement(components_1.GovernanceCard, { ...(excludeCardWrapper && { className: classes.nudeCard }), title: !noHeader ? "Deposit Funds" : undefined, hideDivider: excludeCardWrapper, description: !noLabel
            ? "Move tokens from your Ethereum wallet into your Hypernet account."
            : undefined },
        react_1.default.createElement(formik_1.Formik, { enableReinitialize: true, initialValues: {
                tokenAddress: (_a = tokenSelectorOptions[0]) === null || _a === void 0 ? void 0 : _a.address,
                amount: "1",
                stateChannelAddress: (selectedStateChennel === null || selectedStateChennel === void 0 ? void 0 : selectedStateChennel.channelAddress) ||
                    ((_b = uniqueActiveStateChannels[0]) === null || _b === void 0 ? void 0 : _b.channelAddress),
            }, onSubmit: handleFormSubmit }, ({ handleSubmit, values, setFieldValue }) => {
            return (react_1.default.createElement(formik_1.Form, { onSubmit: handleSubmit },
                selectType === "dialog" ? (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(components_1.GovernanceDialogSelectField, { required: true, title: "Hypernet Account", name: "stateChannelAddress", options: uniqueActiveStateChannels.map((option) => ({
                            primaryText: option.channelAddress,
                            value: option.channelAddress,
                        })) }),
                    react_1.default.createElement(components_1.GovernanceDialogSelectField, { required: true, title: "Token Selector", name: "tokenAddress", options: tokenSelectorOptions.map((option) => ({
                            primaryText: option.name,
                            value: option.address,
                        })) }))) : (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(components_1.GovernanceField, { required: true, type: "select", title: "Hypernet Account", name: "stateChannelAddress", options: uniqueActiveStateChannels.map((option) => ({
                            label: option.channelAddress,
                            value: option.channelAddress,
                        })) }),
                    react_1.default.createElement(components_1.GovernanceField, { required: true, title: "Token Selector", name: "tokenAddress", type: "select", options: tokenSelectorOptions === null || tokenSelectorOptions === void 0 ? void 0 : tokenSelectorOptions.map((option) => ({
                            label: (react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center", p: 0 },
                                option.logoUrl && (react_1.default.createElement("img", { src: option.logoUrl, style: { width: 20, height: 20, marginRight: 8 } })),
                                option.name)),
                            value: option.address,
                        })) }))),
                react_1.default.createElement(components_1.GovernanceField, { required: true, name: "amount", title: "Amount", type: "input", placeholder: "Type Amount", inputProps: {
                        type: "number",
                    } }),
                react_1.default.createElement(components_1.GovernanceButton, { fullWidth: true, color: "primary", variant: "contained", onClick: handleSubmit, disabled: !(!!values.amount &&
                        !!values.tokenAddress &&
                        !!values.stateChannelAddress) }, "Fund my wallet")));
        })));
};
exports.default = FundWidget;
//# sourceMappingURL=FundWidget.js.map