"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const hooks_1 = require("../../hooks");
const theme_1 = require("../../theme");
const components_1 = require("../../components");
const GatewayDeauthorizationModalWidget = ({ gatewayUrl, closeCallback }) => {
    const { deauthorizeGateway } = (0, hooks_1.useGateways)();
    const deauthorizeGatewayConfirmed = () => {
        deauthorizeGateway(gatewayUrl);
        closeCallback();
    };
    return (react_1.default.createElement(components_1.GovernanceDialog, { title: react_1.default.createElement(core_1.Typography, { variant: "h4" }, "Gateway Deauthorization"), isOpen: true, onClose: closeCallback, content: react_1.default.createElement(core_1.Box, { display: "flex", flexDirection: "column" },
            react_1.default.createElement(core_1.Typography, null,
                "Would you like to deauthorize $",
                gatewayUrl),
            react_1.default.createElement(core_1.Box, { marginTop: 3, display: "flex", justifyContent: "flex-end" },
                react_1.default.createElement(components_1.GovernanceButton, { color: "default", onClick: closeCallback, variant: "outlined", size: "small" }, "Cancel"),
                react_1.default.createElement(components_1.GovernanceButton, { onClick: deauthorizeGatewayConfirmed, variant: "contained", color: "secondary", size: "small", style: { backgroundColor: theme_1.colors.RED700, marginLeft: 10 } }, "Deauthorize"))) }));
};
exports.default = GatewayDeauthorizationModalWidget;
//# sourceMappingURL=GatewayDeauthorizationModalWidget.js.map