"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const RegistryLazyMintingRequestsWidget = () => {
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading, handleCoreError } = (0, contexts_1.useLayoutContext)();
    const [lazyMintingSignatures, setLazyMintingSignatures] = (0, react_1.useState)([]);
    const [hasEmptyState, setHasEmptyState] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        getLazyMintSignatures();
    }, []);
    const getLazyMintSignatures = () => {
        setLoading(true);
        coreProxy.registries
            .retrieveLazyMintingSignatures()
            .map((lazyMintingSignatureList) => {
            setLazyMintingSignatures(lazyMintingSignatureList || []);
            if (!lazyMintingSignatureList ||
                lazyMintingSignatureList.length === 0) {
                setHasEmptyState(true);
            }
            setLoading(false);
        })
            .mapErr(handleCoreError);
    };
    const revokeSignature = (lazyMintingSignature) => {
        setLoading(true);
        coreProxy.registries
            .revokeLazyMintSignature(lazyMintingSignature)
            .map(() => {
            getLazyMintSignatures();
            setLoading(false);
        })
            .mapErr(handleCoreError);
    };
    const submitSignature = (lazyMintingSignature) => {
        setLoading(true);
        coreProxy.registries
            .executeLazyMint(lazyMintingSignature)
            .map(() => {
            getLazyMintSignatures();
            setLoading(false);
        })
            .mapErr(handleCoreError);
    };
    return (react_1.default.createElement(core_1.Box, null,
        react_1.default.createElement(components_1.GovernanceWidgetHeader, { label: "Registries Lazy Minting Requests" }),
        hasEmptyState && (react_1.default.createElement(components_1.GovernanceEmptyState, { title: "No registiries lazy minting requests found.", description: "Registiries lazy minting requests submitted by community members will appear here." })), lazyMintingSignatures === null || lazyMintingSignatures === void 0 ? void 0 :
        lazyMintingSignatures.map((lazyMintingSignature, index) => (react_1.default.createElement(components_1.GovernanceRegistryListItem, { key: Number(lazyMintingSignature.tokenId), number: (index + 1).toString(), title: lazyMintingSignature.tokenId.toString(), fieldWithValueList: [
                {
                    fieldTitle: "Signature",
                    fieldValue: lazyMintingSignature.mintingSignature,
                },
                {
                    fieldTitle: "Registrar Address",
                    fieldValue: lazyMintingSignature.registrarAddress,
                },
                {
                    fieldTitle: "Registry Address",
                    fieldValue: lazyMintingSignature.registryAddress,
                },
                {
                    fieldTitle: "Token Claimed",
                    fieldValue: lazyMintingSignature.tokenClaimed ? "Yes" : "No",
                },
            ], actionButtonList: [
                {
                    color: "secondary",
                    label: "Revoke",
                    variant: "text",
                    onClick: () => revokeSignature(lazyMintingSignature),
                },
                {
                    color: "primary",
                    label: "Claim",
                    disabled: lazyMintingSignature.tokenClaimed,
                    onClick: () => submitSignature(lazyMintingSignature),
                },
            ] })))));
};
exports.default = RegistryLazyMintingRequestsWidget;
//# sourceMappingURL=RegistryLazyMintingRequestsWidget.js.map