"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const objects_1 = require("@hypernetlabs/objects");
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const formik_1 = require("formik");
const react_1 = __importDefault(require("react"));
const components_1 = require("../../components");
const TransferIdentityWidget_style_1 = require("../../widgets/TransferIdentityWidget/TransferIdentityWidget.style");
const TransferIdentityWidget = ({ onCloseCallback, onSuccessCallback, registryName, tokenId, }) => {
    const classes = (0, TransferIdentityWidget_style_1.useStyles)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading, handleCoreError } = (0, contexts_1.useLayoutContext)();
    const transferIdentity = (values) => {
        setLoading(true);
        coreProxy.registries
            .transferRegistryEntry(registryName, tokenId, (0, objects_1.EthereumAccountAddress)(values.address))
            .map(() => {
            setLoading(false);
            onSuccessCallback();
        })
            .mapErr(handleCoreError);
    };
    return (react_1.default.createElement(components_1.GovernanceDialog, { title: "Transfer Nonfungible Identity", isOpen: true, onClose: onCloseCallback, content: react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(formik_1.Formik, { enableReinitialize: true, initialValues: {
                    address: "",
                }, onSubmit: transferIdentity }, ({ handleSubmit, values }) => {
                return (react_1.default.createElement(formik_1.Form, { onSubmit: handleSubmit },
                    react_1.default.createElement(components_1.GovernanceField, { title: "Address", name: "address", type: "input", placeholder: "Enter the address", required: true }),
                    react_1.default.createElement(core_1.Box, { className: classes.actionContainer },
                        react_1.default.createElement(components_1.GovernanceButton, { variant: "outlined", color: "primary", onClick: onCloseCallback }, "Cancel"),
                        react_1.default.createElement(components_1.GovernanceButton, { className: classes.saveButton, disabled: !(values === null || values === void 0 ? void 0 : values.address), variant: "contained", color: "primary", onClick: handleSubmit }, "Transfer"))));
            })) }));
};
exports.default = TransferIdentityWidget;
//# sourceMappingURL=TransferIdentityWidget.js.map